/*
** Der umstlpbare Wrfel nach Paul Schatz
** Copyright (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
*/
#ifndef OS_WIN32
#include <config.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <GL/glut.h>
#include <GL/gl.h>

int wTranslateLetterToNumber (char);

#define CHECKOGLERR
#include "wuerfel.h"

void
wKey (unsigned char key, int x, int y) {

/*   static int gkf = 0; */
/*   fprintf (stderr, "glutKeyboardFunc %d\n", ++gkf); */

    switch (key) {
    case 27: /* ESC */
    case 'q':
	wExit ();
	break;
    case '1':
    case '2':
    case '3':
    case '4':
	wSubMenuView ((int)(key - '0'));
        break;
    case ' ':
        wSetImpulse ();
        break;
    case '.':
	wNextPos ();
	break;
    case ',':
	wPrevPos ();
	break;
    case 'a':
	wToggleAxis ();
	break;
    case 'A':
	wToggleAutomatic ();
	break;
    case 'b':
	wToggleTouchline ();
	break;
    case 'B':
	wToggleBeide ();
	break;
    case 'c':
	wAdvanceAxisTransform ();
	break;
    case 'D':
	wToggleDiagonals ();
	break;
    case 'e':
	wToggleEndpunkte ();
	break;
    case 'g':
	wToggleGitterFlaechen ();
	break;
    case 'H':
        wToggleAngle2 ();
	break;
    case 'i':
        wToggleInfo ();
	break;
    case 'k':
        wToggleKuboid ();
	break;
    case 'l':
        wToggleLabels ();
	break;
    case 'L':
	wToggleIndilTimeform ();
	break;
    case 'M':
	wToggleCenter ();
	break;
    case 'o':
        wToggleOloid ();
	break;
    case 'p':
	wTogglePerspektive ();
	break;
    case 'P':
	wToggleIndipTimeform ();
	break;
    case 'r':
	wToggleErzeugende ();
	break;
    case 's':
	wToggleHalt ();
	break;
    case 't':
	wToggleTorkeln ();
	break;
    case 'v':
	wToggleVirtuell ();
	break;
    case 'V':
	wToggleFullform ();
	break;
    case 'w':
        wToggleWuerfelguertel ();
	break;
    case 'W':
        wToggleAngle1 ();
	break;
    case 'x':
	rotx += 1.;
	wThisPos ();
	break;
    case 'y':
	roty += 1.;
	wThisPos ();
	break;
    case 'z':
	rotz += 1.;
	wThisPos ();
	break;
    case 'X':
	rotx -= 1.;
	wThisPos ();
	break;
    case 'Y':
	roty -= 1.;
	wThisPos ();
	break;
    case 'Z':
	rotz -= 1.;
	wThisPos ();
	break;
    case '+':
	wSubMenuSpeed (1);
	break;
    case '-':
	wSubMenuSpeed (2);
	break;
    default:
        fprintf (stderr, "Taste <%c> ignoriert\n", key);
	return;
    }
    
    /* wenn sich was an den Optionen aendert, diese erneut anzeigen */
    switch (key) {
    case '1':
    case '2':
    case '3':
    case '4':
    case 'a':
    case 'A':
    case 'b':
    case 'c':
    case 'D':
    case 'e':
    case 'g':
    case 'H':
    case 'i':
    case 'k':
    case 'l':
    case 'L':
    case 'M':
    case 'o':
    case 'p':
    case 'P':
    case 'r':
    case 't':
    case 'v':
    case 'V':
    case 'w':
    case 'W':
    case '+':
    case '-':
        wDisplayOptions ();
	break;
    default:
	return;
    }
    wPostRedisplay ();
}

void
wSpecialKey (int key, int x, int y) {

/*   static int gsf = 0; */
/*   fprintf (stderr, "glutSpecialFunc %d\n", ++gsf); */

    switch (key) {
    case GLUT_KEY_UP:
	trany += 0.1;
	break;
    case GLUT_KEY_DOWN:
	trany -= 0.1;
	break;
    case GLUT_KEY_LEFT:
	tranx -= 0.1;
	break;
    case GLUT_KEY_RIGHT:
	tranx += 0.1;
	break;
    case GLUT_KEY_PAGE_UP:
	tranz += 0.1;
	break;
    case GLUT_KEY_PAGE_DOWN:
	tranz -= 0.1;
	break;
    case GLUT_KEY_HOME:
        wResetRotation ();
	break;
    case GLUT_KEY_END:
        wResetAll ();
	break;
    default:
        fprintf (stderr, "Taste <%c> ignoriert\n", key);
	return;
    }
    wPostRedisplay ();
}

void
wCreateMenus (void) {

    /* View-Submenue */
    menIdMainSubView = glutCreateMenu (wSubMenuView);
    glutAddMenuEntry ("<1> Hauptdiagonale fixiert", 1);
    glutAddMenuEntry ("<2> Scharnier fixiert", 2);
    glutAddMenuEntry ("<3> Element fixiert", 3);
    glutAddMenuEntry ("<4> Mittelpunkt fixiert", 4);

    /* Planetenbahnen-Submenue */
    menIdMainSubPoints = glutCreateMenu (wSubMenuPoints);
    glutAddMenuEntry ("Initialisieren", 0);
    glutAddMenuEntry ("Punkt a", 1);
    glutAddMenuEntry ("Punkt b", 3);
    glutAddMenuEntry ("Punkt c", 7);
    glutAddMenuEntry ("Punkt d", 5);
    glutAddMenuEntry ("Punkt e", 17);
    glutAddMenuEntry ("Punkt f", 13);
    glutAddMenuEntry ("Punkte b,c,d", 90);
    glutAddMenuEntry ("Punkte b,e", 91);

    /* Linien-Submenue */
    menIdMainSubLines = glutCreateMenu (wSubMenuLines);
    glutAddMenuEntry ("Initialisieren", 0);
    glutAddMenuEntry ("Linie b-c", 1);
    glutAddMenuEntry ("Linie c-d", 2);
    glutAddMenuEntry ("Linie d-e", 3);
    glutAddMenuEntry ("Linie e-f", 4);
    glutAddMenuEntry ("Linie b-e", 5);

    /* Geschwindigkeit-Submenue */
    menIdMainSubSpeed = glutCreateMenu (wSubMenuSpeed);
    glutAddMenuEntry ("<+> Schneller", 1);
    glutAddMenuEntry ("<-> Langsamer", 2);

    /* Create main menu for main window */
    menIdMain = glutCreateMenu (wMainMenu);

    /* Die Submenues zu Beginn */
    glutAddSubMenu ("Geschwindigkeit", menIdMainSubSpeed);
    glutAddSubMenu ("Ansicht", menIdMainSubView);
    glutAddSubMenu ("Bahnen der Punkte", menIdMainSubPoints);
    glutAddSubMenu ("Linien", menIdMainSubLines);

    /* Nach den Submenues die einzelnen Optionen */
    if (options.tork) {
        glutAddMenuEntry ("<t> Schweben aus", 5);
    }
    else {
        glutAddMenuEntry ("<t> Schweben ein", 5);
    }
    if (options.virtuell) {
        glutAddMenuEntry ("<v> Virtuelle Ecken aus", 6);
    }
    else {
        glutAddMenuEntry ("<v> Virtuelle Ecken ein", 6);
    }
    if (options.ach) {
        glutAddMenuEntry ("<a> Achsen aus", 7);
    }
    else {
        glutAddMenuEntry ("<a> Achsen ein", 7);
    }
    if (options.perspektive) {
        glutAddMenuEntry ("<p> Projektion parallel", 8);
    }
    else {
        glutAddMenuEntry ("<p> Projektion perspektivisch", 8);
    }
    if (options.lines) {
        glutAddMenuEntry ("<g> Flchen", 9);
    }
    else {
        glutAddMenuEntry ("<g> Gitter", 9);
    }
    if (options.labels) {
        glutAddMenuEntry ("<l> Labels aus", 10);
    }
    else {
        glutAddMenuEntry ("<l> Labels ein", 10);
    }
    if (options.kuboid) {
        glutAddMenuEntry ("<k> Kuboid aus", 11);
    }
    else {
        glutAddMenuEntry ("<k> Kuboid ein", 11);
    }
    if (options.oloid) {
        glutAddMenuEntry ("<o> Oloid aus", 12);
    }
    else {
        glutAddMenuEntry ("<o> Oloid ein", 12);
    }
    if (options.beide) {
        glutAddMenuEntry ("<B> Beide aus", 13);
    }
    else {
        glutAddMenuEntry ("<B> Beide ein", 13);
    }
    if (options.wuerfel) {
        glutAddMenuEntry ("<w> Wrfelgrtel aus", 14);
    }
    else {
        glutAddMenuEntry ("<w> Wrfelgrtel ein", 14);
    }
    if (options.touchline) {
        glutAddMenuEntry ("<b> Berhrungslinie aus", 15);
    }
    else {
        glutAddMenuEntry ("<b> Berhrungslinie ein", 15);
    }
    if (options.erzeugende) {
        glutAddMenuEntry ("<r> Flche der Zeitform aus", 16);
    }
    else {
        glutAddMenuEntry ("<r> Flche der Zeitform ein", 16);
    }
    if (options.endpunkte) {
        glutAddMenuEntry ("<e> Endpunkte aus", 17);
    }
    else {
        glutAddMenuEntry ("<e> Endpunkte ein", 17);
    }
    if (options.info) {
        glutAddMenuEntry ("<i> Info aus", 18);
    }
    else {
        glutAddMenuEntry ("<i> Info ein", 18);
    }
    glutAddMenuEntry ("<c> nchste Achsentransf.", 19);
    if (options.automatic) {
        glutAddMenuEntry ("<A> Automatik aus", 20);
    }
    else {
        glutAddMenuEntry ("<A> Automatik ein", 20);
    }
    if (options.diagonals) {
        glutAddMenuEntry ("<D> Diagonalen aus", 21);
    }
    else {
        glutAddMenuEntry ("<D> Diagonalen ein", 21);
    }
    if (options.center) {
        glutAddMenuEntry ("<M> Mittelpunkt aus", 22);
    }
    else {
        glutAddMenuEntry ("<M> Mittelpunkt ein", 22);
    }
    if (options.angle1) {
        glutAddMenuEntry ("<W> Winkel x/1-2 aus", 23);
    }
    else {
        glutAddMenuEntry ("<W> Winkel x/1-2 ein", 23);
    }
    if (options.angle2) {
        glutAddMenuEntry ("<H> Winkel y/1-3 aus", 24);
    }
    else {
        glutAddMenuEntry ("<H> Winkel y/1-3 ein", 24);
    }
    if (options.fullform) {
        glutAddMenuEntry ("<V> Halbe Zeitform", 25);
    }
    else {
        glutAddMenuEntry ("<V> Volle Zeitform", 25);
    }

    glutAddMenuEntry ("<q> Ende", 26);

    glutAttachMenu (GLUT_RIGHT_BUTTON);
}

void
wSubMenuView (int value) {
    switch (value) {
    case 1:
    case 2:
    case 3:
    case 4:
	options.mode = value;
	break;
    }
}

void
wSubMenuPoints (int value) {
    if (value > 0 && anztfpp >= MAXTFPL) {
        fprintf (stderr, "Zu viele Punkte angefordert, maximal %d mglich\n", MAXTFPL);
        fprintf (stderr, "Beginnen Sie mit Initialisieren\n", MAXTFPL);
        return;
    }

    switch (value) {
    case 0:
        options.indip = FALSE;
        anztfpp = 0;
        break;
    case 3:
    case 7:
    case 5:
    case 17:
    case 13:
	options.indip = TRUE;
	tfpp[++anztfpp] = value;
	break;
    case 90:
	options.indip = TRUE;
	tfpp[++anztfpp] = 3;
	tfpp[++anztfpp] = 7;
	tfpp[++anztfpp] = 5;
	break;
    case 91:
	options.indip = TRUE;
	tfpp[++anztfpp] = 3;
	tfpp[++anztfpp] = 17;
	break;
    }
    wDisplayOptions ();
    wCreateDisplayLists ();
}

void
wSubMenuLines (int value) {
    if (value > 0 && anztfpl >= MAXTFPL) {
        fprintf (stderr, "Zu viele Linien angefordert, maximal %d mglich\n", MAXTFPL/2);
        fprintf (stderr, "Beginnen Sie mit Initialisieren\n", MAXTFPL);
        return;
    }

    switch (value) {
    case 0:
        options.indil = FALSE;
        anztfpl = 0;
        break;
    case 1:
        options.indil = TRUE;
	tfpl[++anztfpl] = 3;
	tfpl[++anztfpl] = 7;
	break;
    case 2:
        options.indil = TRUE;
	tfpl[++anztfpl] = 7;
	tfpl[++anztfpl] = 5;
	break;
    case 3:
        options.indil = TRUE;
	tfpl[++anztfpl] = 5;
	tfpl[++anztfpl] = 17;
	break;
    case 4:
        options.indil = TRUE;
	tfpl[++anztfpl] = 17;
	tfpl[++anztfpl] = 13;
	break;
    case 5:
        options.indil = TRUE;
	tfpl[++anztfpl] = 3;
	tfpl[++anztfpl] = 17;
	break;
    }
    wDisplayOptions ();
    wCreateDisplayLists ();
}

void
wSubMenuAxis (int value) {
    wAdvanceAxisTransform ();
}

void
wSubMenuSpeed (int value) {
    switch (value) {
    case 1:
	waittime.tv_usec /= 2;
	break;
    case 2:
	if (waittime.tv_usec > 1000000) {
	    fprintf (stderr, "Zeitintervall bereits > 1 sek, Eingabe ignoriert\n");
	    return;
	}
        waittime.tv_usec *= 2;
	if (waittime.tv_usec == 0) {waittime.tv_usec = 1;}
	break;
    }
}

void
wGetTimeformPointsl () {
    char tfpltxt[BUFSIZ];
    int i, n;
    char *cp;
    BOOLEAN ok = FALSE;

    while (!ok) {

        fprintf (stderr, "\n");
        fprintf (stderr, "Linienzug fr die Zeitform eingeben, Format: von1-nach1,von2-nach2,...\n");
	scanf ("%s", &tfpltxt);
	fprintf (stderr, "Eingabe war: <%s>\n", &tfpltxt);

	i = 0;
	cp = (char *)strtok (tfpltxt, "-,");
	n = wTranslateLetterToNumber (*cp);
	if (n > 0) {
	    tfpl[++i] = n;
	}
	else {
	    fprintf (stderr, "Punkt <%c> nicht vorgesehen, es stehen nur die Punkte a - f zur Auswahl\n",
		     *cp);
	    fprintf (stderr, "bitte wiederholen\n");
	    continue;
	}
	fprintf (stderr, "Punkt %d = %c\n", i, *cp);

/*      frueher direkte Eingabe der Punkte */
/* 	sscanf (cp, "%d", &tfpl[++i]); */
/* 	if (tfpl[i] < 1 || ANZPUNKTE < tfpl[i]) { */
/* 	    fprintf (stderr, "Punkt %d war %d, es stehen nur die Punkte 1 - %d zur Auswahl\n", */
/* 		     i, tfpl[i], ANZPUNKTE); */
/* 	    fprintf (stderr, "bitte wiederholen\n"); */
/* 	    continue; */
/* 	} */
/* 	else { */
/* 	    fprintf (stderr, "Punkt %d = %d\n", i, tfpl[i]); */
/* 	} */

	while ((i < MAXTFPL) && (cp = (char *)strtok (NULL, "-,"))) {
	    n = wTranslateLetterToNumber (*cp);
	    if (n > 0) {
	        tfpl[++i] = n;
	    }
	    else {
	        fprintf (stderr, "Punkt <%c> nicht vorgesehen, es stehen nur die Punkte a - f zur Auswahl\n",
			 *cp);
		fprintf (stderr, "bitte wiederholen\n");
		continue;
	    }
	    fprintf (stderr, "Punkt %d = %c\n", i, *cp);
	}
	if (i % 2 != 0) {
	    fprintf (stderr, "%d Punkte eingegeben. Es ist eine positive, gerade Anzahl von Punkten ...\n", i);
	    fprintf (stderr, "erforderlich. Jeweils Beginn- und Endpunkt einer Line. Bitte widerholen\n");
	}
	else {
	    ok = TRUE;
	}
    }
    anztfpl = i;
    wCreateDisplayLists ();
}

int
wTranslateLetterToNumber (char c) {
	switch (c) {
	case 'a':
            return 1;
	    ;;
	case 'A':
            return 2;
	    ;;
	case 'b':
            return 3;
	    ;;
	case 'B':
            return 4;
	    ;;
	case 'c':
            return 7;
	    ;;
	case 'C':
            return 8;
	    ;;
	case 'd':
            return 5;
	    ;;
	case 'D':
            return 6;
	    ;;
	case 'e':
            return 17;
	    ;;
	case 'E':
            return 18;
	    ;;
	case 'f':
            return 13;
	    ;;
	case 'F':
            return 14;
	    ;;
	case 'm':
            return 22;
	    ;;
	default:
	    return -1;
	    ;;
	}
}

void
wGetTimeformPointsp () {
    char tfpltxt[BUFSIZ];
    int i, n;
    char *cp;
    BOOLEAN ok = FALSE;

    while (!ok) {

        fprintf (stderr, "\n");
        fprintf (stderr, "Punktlist fr die Zeitform eingeben, Format: punkt1,punkt2,...\n");
	scanf ("%s", &tfpltxt);
	fprintf (stderr, "Eingabe war: <%s>\n", &tfpltxt);

	i = 0;
	cp = (char *)strtok (tfpltxt, ",");
	n = wTranslateLetterToNumber (*cp);
	if (n > 0) {
	    tfpp[++i] = n;
	}
	else {
	    fprintf (stderr, "Punkt <%c> nicht vorgesehen, es stehen die Punkte a-f und A-F zur Auswahl\n",
		     *cp);
	    fprintf (stderr, "bitte wiederholen\n");
	    continue;
	}
	fprintf (stderr, "Punkt %d = %c\n", i, *cp);

	while ((i < MAXTFPL) && (cp = (char *)strtok (NULL, ","))) {
	    n = wTranslateLetterToNumber (*cp);
	    if (n > 0) {
	        tfpp[++i] = n;
	    }
	    else {
	        fprintf (stderr, "Punkt <%c> nicht vorgesehen, es stehen nur die Punkte a - f zur Auswahl\n",
			 *cp);
		fprintf (stderr, "bitte wiederholen\n");
		continue;
	    }
	    fprintf (stderr, "Punkt %d = %c\n", i, *cp);
	}
	if (i == 0) {
	    fprintf (stderr, "%d Punkte eingegeben. Es ist eine positive Anzahl von Punkten ...\n", i);
	    fprintf (stderr, "erforderlich. Bitte widerholen\n");
	}
	else {
	    ok = TRUE;
	}
    }
    anztfpp = i;
    wCreateDisplayLists ();
}

void
wMainMenu(int value){

    switch(value){
    case 5:
	wToggleTorkeln ();
	break;
    case 6:
	wToggleVirtuell ();
	break;
    case 7:
	wToggleAxis ();
	break;
    case 8:
	wTogglePerspektive ();
	break;
    case 9:
	wToggleGitterFlaechen ();
	break;
    case 10:
	wToggleLabels ();
	break;
    case 11:
	wToggleKuboid ();
	break;
    case 12:
	wToggleOloid ();
	break;
    case 13:
	wToggleBeide ();
	break;
    case 14:
	wToggleWuerfelguertel ();
	break;
    case 15:
	wToggleTouchline ();
	break;
    case 16:
	wToggleErzeugende ();
	break;
    case 17:
	wToggleEndpunkte ();
	break;
    case 18:
	wToggleInfo ();
	break;
    case 19:
	wAdvanceAxisTransform ();
	break;
    case 20:
	wToggleAutomatic ();
	break;
    case 21:
	wToggleDiagonals ();
	break;
    case 22:
	wToggleCenter ();
	break;
    case 23:
	wToggleAngle1 ();
	break;
    case 24:
	wToggleAngle2 ();
	break;
    case 25:
	wToggleFullform ();
	break;
    case 26:
	wExit ();
	break;
    }
    wDisplayOptions ();
}

void
wToggleTorkeln (void) {
      if(options.tork) {
	  glutChangeToMenuEntry(5, "<t> Schweben ein", 5);
      }
      else {
	  glutChangeToMenuEntry(5, "<t> Schweben aus", 5);
      }
      options.tork = ! options.tork;
}

void
wToggleVirtuell (void) {
      if(options.virtuell) {
	  glutChangeToMenuEntry(6, "<e> Virtuelle Ecken ein", 6);
      }
      else {
	  glutChangeToMenuEntry(6, "<e> Virtuelle Ecken aus", 6);
      }
      options.virtuell = ! options.virtuell;
}

void
wToggleAxis (void) {
      if(options.ach) {
	  glutChangeToMenuEntry(7, "<a> Achsen ein", 7);
      }
      else {
	  glutChangeToMenuEntry(7, "<a> Achsen aus", 7);
      }
      options.ach = ! options.ach;
}

void
wTogglePerspektive (void) {
      if(options.perspektive) {
	  glutChangeToMenuEntry(8, "<p> Projektion perspektivisch", 8);
      }
      else {
	  glutChangeToMenuEntry(8, "<p> Projektion parallel", 8);
      }
      options.perspektive = ! options.perspektive;
      wReshape (options.seite, options.seite);
}

void
wToggleGitterFlaechen (void) {
      if(options.lines) {
	  glutChangeToMenuEntry(9, "<g> Gitter", 9);
      }
      else {
	  glutChangeToMenuEntry(9, "<g> Flchen", 9);
      }
      options.lines = ! options.lines;
      /* polygonMode sollte erst beim Ausgeben gesetzt werden */
      if (polygonMode == GL_LINE) {
	  polygonMode = GL_FILL;
      }
      else {
	  polygonMode = GL_LINE;
      }
      wErr(glPolygonMode (GL_FRONT_AND_BACK, polygonMode));
}

void
wToggleLabels (void) {
      if(options.labels) {
	  glutChangeToMenuEntry(10, "<l> Labels ein", 10);
      }
      else {
	  glutChangeToMenuEntry(10, "<l> Labels aus", 10);
      }
      options.labels = ! options.labels;
/*       wCreateDisplayLists (); */
}

void
wToggleKuboid (void) {
      if(options.kuboid) {
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(11, "<k> Kuboid ein", 11);
	  options.axistrans = savedaxistrans;
      }
      else {
          options.kuboid = TRUE;
	  glutChangeToMenuEntry(11, "<k> Kuboid aus", 11);
          options.oloid = FALSE;
	  glutChangeToMenuEntry(12, "<o> Oloid ein", 12);
	  savedaxistrans = options.axistrans;
	  options.axistrans = 2; /* Achsentransformation fuer Kuboid */
	  /* rotx = rotz = 0; */      /* in eine Ausgangsposition */
      }
      wCreateDisplayLists ();
}

void
wToggleOloid (void) {
      if(options.oloid) {
	  options.oloid = FALSE;
	  glutChangeToMenuEntry(12, "<o> Oloid ein", 12);
	  options.axistrans = savedaxistrans;
      }
      else {
          options.oloid = TRUE;
	  glutChangeToMenuEntry(12, "<o> Oloid aus", 12);
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(11, "<k> Kuboid ein", 11);
	  savedaxistrans = options.axistrans;
	  options.axistrans = 3; /* Achsentransformation fuer Oloid */
	  /* rotx = rotz = 0; */      /* in eine Ausgangsposition */
      }
      wCreateDisplayLists ();
}

void
wToggleIndilTimeform (void) {
      if(options.indil) {
	  options.indil = FALSE;
	  anztfpl = 0;
      }
      else {
          options.indil = TRUE;
	  wGetTimeformPointsl ();
      }
      wCreateDisplayLists ();
}

void
wToggleIndipTimeform (void) {
      if(options.indip) {
	  options.indip = FALSE;
	  anztfpp = 0;
      }
      else {
          options.indip = TRUE;
	  wGetTimeformPointsp ();
      }
      wCreateDisplayLists ();
}

void
wToggleBeide (void) {
      if(options.beide) {
	  options.beide = FALSE;
	  glutChangeToMenuEntry(13, "<B> Beide ein", 13);
      }
      else {
          options.beide = TRUE;
	  glutChangeToMenuEntry(13, "<B> Beide aus", 13);
      }
      wCreateDisplayLists ();
}

void
wToggleWuerfelguertel (void) {
      if(options.wuerfel) {
	  glutChangeToMenuEntry(14, "<w> Wrfelgrtel ein", 14);
      }
      else {
	  glutChangeToMenuEntry(14, "<w> Wrfelgrtel aus", 14);
      }
      options.wuerfel = ! options.wuerfel;
}

void
wToggleTouchline (void) {
      if(options.touchline) {
	  glutChangeToMenuEntry(15, "<b> Berhrungslinie ein", 15);
      }
      else {
	  glutChangeToMenuEntry(15, "<b> Berhrungslinie aus", 15);
      }
      options.touchline = ! options.touchline;
/*       wCreateDisplayLists (); */
}

void
wToggleErzeugende (void) {
      if(options.erzeugende) {
	  glutChangeToMenuEntry(16, "<r> Flche der Zeitform ein", 16);
      }
      else {
	  glutChangeToMenuEntry(16, "<r> Flche der Zeitform aus", 16);
      }
      options.erzeugende = ! options.erzeugende;
/*       wCreateDisplayLists (); */
}

void
wToggleEndpunkte (void) {
      if(options.endpunkte) {
	  glutChangeToMenuEntry(17, "<e> Endpunkte ein", 17);
      }
      else {
	  glutChangeToMenuEntry(17, "<e> Endpunkte aus", 17);
      }
      options.endpunkte = ! options.endpunkte;
/*       wCreateDisplayLists (); */
}

void
wAdvanceAxisTransform (void) {
  fprintf (stderr, "options.axistrans=%d, wird weitergeschaltet\n", options.axistrans);
      options.axistrans +=1;
      if (options.axistrans > 3) {
	options.axistrans = 1;
      };
      wCreateDisplayLists ();
}

void
wResetRotation () {
  static int homeposition = 0;
  /*
  ** Ansicht in eine achsiale Lage bringen
  ** dabei werden jedenfalls die Werte fuer die Schwebebewegung auf 0 gesetzt.
  ** Die Werte fuer die Drehbewegung des Bewegungssystems selbst werden der
  ** Reihe nach fuer alle 3 Achsen auf 0, dann 90 Grad gesetzt.
  */
      drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
      tranx = trany = tranz = 0.;

      switch (homeposition) {
      case 0:
	rotx = roty = rotz = 0.;
	break;
      case 1:
	rotx = 90.;
	roty = rotz = 0.;
	break;
      case 2:
	rotx = -90.;
	roty = rotz = 90.;
	break;
      }
      homeposition = ++homeposition % 3;

      wCreateDisplayLists ();
}

void
wResetAll () {
  /*
  ** Ansicht in die Normalpostion bringen. Dabei wird folgendes auf 0 gesetzt
  ** +) die Werte fuer die Schwebebewegung
  ** +) Die Werte fuer die Drehbewegung des Bewegungssystems
  ** +) die Achsentransformation
  ** +) die Ansichtstransformation (nicht ganz, Ansicht ein wenig von rechts oben)
  */
      drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
      tranx = trany = tranz = 0.;
/*       rotx = roty = rotz = 0.; */
      rotx = 10;
      roty = -10;
      rotz = 0;
      options.tork = 0;
      options.axistrans = 1;
      options.mode = 1;

      wCreateDisplayLists ();
      wDisplayOptions ();
}

void
wToggleInfo (void) {
      if(options.info) {
	  glutChangeToMenuEntry(18, "<i> Info ein", 18);
      }
      else {
	  glutChangeToMenuEntry(18, "<i> Info aus", 18);
      }
      glutSetWindow (winIdSub);
      if (options.info) {
          glutHideWindow();
      }
      else {
          glutShowWindow();
      }
      options.info = ! options.info;
}

void
wToggleAutomatic (void) {
      if(options.automatic) {
	  glutChangeToMenuEntry(16, "<A> Automatik ein", 16);
      }
      else {
	  glutChangeToMenuEntry(16, "<A> Automatik aus", 16);
      }
      options.automatic = ! options.automatic;
}

void
wSetImpulse (void) {
      options.impulse = TRUE;
}

void
wToggleDiagonals (void) {
      if(options.diagonals) {
	  options.diagonals = FALSE;
	  glutChangeToMenuEntry(21, "<D> Diagonalen ein", 21);
      }
      else {
          options.diagonals = TRUE;
	  glutChangeToMenuEntry(21, "<D> Diagonalen aus", 21);
      }
      wCreateDisplayLists ();
}

void
wToggleCenter (void) {
      if(options.center) {
	  options.center = FALSE;
	  glutChangeToMenuEntry(22, "<M> Mittelpunkt ein", 22);
      }
      else {
          options.center = TRUE;
	  glutChangeToMenuEntry(22, "<M> Mittelpunkt aus", 22);
      }
      wCreateDisplayLists ();
}

void
wToggleAngle1 (void) {
      if(options.angle1) {
	  options.angle1 = FALSE;
	  glutChangeToMenuEntry(23, "<W> Winkel x/1-2 ein", 23);
      }
      else {
          options.angle1 = TRUE;
	  options.mode = 1;
	  options.axistrans = 1;
	  glutChangeToMenuEntry(23, "<W> Winkel x/1-2 aus", 23);
	  options.angle2 = FALSE;
	  glutChangeToMenuEntry(24, "<H> Winkel y/1-3 ein", 24);
      }
      wCreateDisplayLists ();
}

void
wToggleAngle2 (void) {
      if(options.angle2) {
	  options.angle2 = FALSE;
	  glutChangeToMenuEntry(24, "<H> Winkel y/1-3 ein", 24);
      }
      else {
          options.angle2 = TRUE;
	  options.mode = 1;
	  options.axistrans = 2;
	  glutChangeToMenuEntry(24, "<H> Winkel y/1-3 aus", 24);
	  options.angle1 = FALSE;
	  glutChangeToMenuEntry(23, "<W> Winkel x/1-2 ein", 23);
      }
      wCreateDisplayLists ();
}

void
wToggleFullform (void) {
      if(options.fullform) {
	  options.fullform = FALSE;
	  glutChangeToMenuEntry(25, "<V> Volle Zeitform", 25);
      }
      else {
          options.fullform = TRUE;
	  glutChangeToMenuEntry(25, "<V> Halbe Zeitform", 25);
      }
      wCreateDisplayLists ();
}

void
wToggleHalt (void) {
      halt = !halt;
}

void
wExit (void) {
      exit (1);
}
